set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
 
select name n from v$database;
select user u from dual;
set sqlprompt &ns:&us>

set head on
set echo on
set termout on
set trimspool on

spool &ns.testcase1.log

set define off
set timing on

-- in this test we want to trigger
-- the case were the active sql has
-- a plan that isn't the most frequently executed
-- but whose elapsed time is 10 x that of
-- the most frequent.  Assumes the query actually
-- is executing and not running forever.

-- create test table and populate with rows

drop table test;

create table test as
select * from dba_tables
where rownum < 101;

insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;

-- add a single test row to access using an index

insert into test (owner,table_name) values ('XYZ','XYZ');
commit;

-- gather stats

execute dbms_stats.gather_table_stats(NULL,'TEST');

-- create index

create index testi on test (owner,table_name);

-- do snapshot before

execute dbms_workload_repository.create_snapshot;

-- run query 100 times with index
-- number in comment can be incremented to make 
-- unique for subsequent tests

select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';

-- do snapshot after

execute dbms_workload_repository.create_snapshot;

-- drop index

drop index testi;

-- run query with slow plan 99 times
-- so it is less frequent

select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';
select /* 9 */ owner,table_name from test where owner='XYZ' and table_name='XYZ';

spool off
