set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set head off;
set verify off;
set termout off;
 
column u new_value us noprint;
column n new_value ns noprint;
 
select name n from v$database;
select user u from dual;
set sqlprompt &ns:&us>

set head on
set echo on
set termout on
set trimspool on

spool &ns.testcase2.log

set define off
set timing on

-- in this test we want to trigger
-- the case were the active sql has
-- a plan that isn't the most frequently executed
-- and where the active sql has never completed
-- and has run more than ten times the average
-- of the most frequently executed plan

-- create test table and populate with rows

drop table test;

create table test as
select * from dba_tables
where rownum < 101;

insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;
insert /*+ append */ into test select * from test;
commit;

-- add a single test row to access using an index

insert into test (owner,table_name) values ('XYZ','XYZ');
commit;

-- gather stats

execute dbms_stats.gather_table_stats(NULL,'TEST');

-- create index

create index testi on test (owner,table_name,num_rows);

-- run query 100 times with index
-- number in comment can be incremented to make 
-- unique for subsequent tests

update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';

commit;

-- do snapshot

execute dbms_workload_repository.create_snapshot;

-- drop index

drop index testi;

-- pause long enough so I can run an update in another window so it will 
-- cause the update to hang.

host sleep 60

update /* 6 */ test set num_rows = 5 where owner='XYZ' and table_name='XYZ';
select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

commit;

spool off
